package jp.chiheisen;

import java.io.IOException;
import java.lang.reflect.Modifier;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

import jp.chiheisen.util.SortUtils;

public class Main {
	
	/**
	 * \bh͂Av쐬vOłB<br>
	 * <br>
	 * ̃vO̎sɂ́AJDK(Java Developers Kit)KvłB<br>
	 * ́AvOJavaRpCgp邽߂łB<br>
	 * ̏ڍׂ́A{@link PackageParser#getClassNameList()}mFĂB<br>
	 * 
	 * @param args Ȃ
	 */
	public static void main(String[] args) throws IOException, ClassNotFoundException{
		List<String> packageNameList = Arrays.asList(new String[]{"java", "javax"});
		List<String> classNameList = PackageParser.getClassNameList(packageNameList);
		List<String> methodNameList = ClassParser.getMethodNameList(classNameList, Modifier.PUBLIC, Modifier.PUBLIC | Modifier.PROTECTED);
		
		MethodNameAnalyzer analyzer = new MethodNameAnalyzer(methodNameList);
		List<Map.Entry<String, Integer>> prefix = SortUtils.sort(analyzer.getPrefix());
		List<Map.Entry<String, Integer>> word = SortUtils.sort(analyzer.getWord());
		
		System.out.println("===== Prefix =====");
		for(Map.Entry<String, Integer> entry : prefix){
			System.out.println(entry);			
		}
		System.out.println();
		
		System.out.println("===== Word =====");
		for(Map.Entry<String, Integer> entry : word){
			System.out.println(entry);			
		}
		System.out.println();

		System.out.println("===== Minimum =====");
		for(String str : analyzer.getMin()){
			System.out.println(str);			
		}
		System.out.println();
		
		System.out.println("===== Maximum =====");
		for(String str : analyzer.getMax()){
			System.out.println(str);			
		}
		System.out.println();
	}
}
